JUCE: AudioSource Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
AudioSource Class Referenceabstract
juce_audio_basics » sources

Base class for objects that can produce a continuous stream of audio. More...

`#include <juce_AudioSource.h>`

Inheritance diagram for AudioSource:

## Public Member Functions
virtual | ~AudioSource ()=default
| Destructor.
virtual void | prepareToPlay (int samplesPerBlockExpected, double sampleRate)=0
| Tells the source to prepare for playing.
virtual void | releaseResources ()=0
| Allows the source to release anything it no longer needs after playback has stopped.
virtual void | getNextAudioBlock (const AudioSourceChannelInfo &bufferToFill)=0
| Called repeatedly to fetch subsequent blocks of audio data.

## Protected Member Functions
| AudioSource ()=default
| Creates an AudioSource.

## Detailed Description

Base class for objects that can produce a continuous stream of audio.

An AudioSource has two states: 'prepared' and 'unprepared'.

When a source needs to be played, it is first put into a 'prepared' state by a call to prepareToPlay(), and then repeated calls will be made to its getNextAudioBlock() method to process the audio data.

Once playback has finished, the releaseResources() method is called to put the stream back into an 'unprepared' state.

See also
  AudioFormatReaderSource, ResamplingAudioSource

## Constructor & Destructor Documentation

## ◆ AudioSource()

AudioSource::AudioSource | ( |  | ) |
| protecteddefault

Creates an AudioSource.

## ◆ ~AudioSource()

virtual AudioSource::~AudioSource | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ prepareToPlay()

virtual void AudioSource::prepareToPlay | ( | int | samplesPerBlockExpected,
|  | double | sampleRate
| ) |  |
| pure virtual

Tells the source to prepare for playing.

An AudioSource has two states: prepared and unprepared.

The prepareToPlay() method is guaranteed to be called at least once on an 'unprepared' source to put it into a 'prepared' state before any calls will be made to getNextAudioBlock(). This callback allows the source to initialise any resources it might need when playing.

Once playback has finished, the releaseResources() method is called to put the stream back into an 'unprepared' state.

Note that this method could be called more than once in succession without a matching call to releaseResources(), so make sure your code is robust and can handle that kind of situation.

Parameters

  samplesPerBlockExpected | the number of samples that the source will be expected to supply each time its getNextAudioBlock() method is called. This number may vary slightly, because it will be dependent on audio hardware callbacks, and these aren't guaranteed to always use a constant block size, so the source should be able to cope with small variations.
  sampleRate | the sample rate that the output will be used at - this is needed by sources such as tone generators.

See also
  releaseResources, getNextAudioBlock

Implemented in BufferingAudioSource, ChannelRemappingAudioSource, IIRFilterAudioSource, MemoryAudioSource, MixerAudioSource, ResamplingAudioSource, ReverbAudioSource, ToneGeneratorAudioSource, AudioTransportSource, AudioFormatReaderSource, and AudioAppComponent.

## ◆ releaseResources()

virtual void AudioSource::releaseResources | ( |  | ) |
| pure virtual

Allows the source to release anything it no longer needs after playback has stopped.

This will be called when the source is no longer going to have its getNextAudioBlock() method called, so it should release any spare memory, etc. that it might have allocated during the prepareToPlay() call.

Note that there's no guarantee that prepareToPlay() will actually have been called before releaseResources(), and it may be called more than once in succession, so make sure your code is robust and doesn't make any assumptions about when it will be called.

See also
  prepareToPlay, getNextAudioBlock

Implemented in BufferingAudioSource, ChannelRemappingAudioSource, IIRFilterAudioSource, MemoryAudioSource, MixerAudioSource, ResamplingAudioSource, ReverbAudioSource, ToneGeneratorAudioSource, AudioTransportSource, AudioFormatReaderSource, and AudioAppComponent.

## ◆ getNextAudioBlock()

virtual void AudioSource::getNextAudioBlock | ( | const AudioSourceChannelInfo & | bufferToFill | ) |
| pure virtual

Called repeatedly to fetch subsequent blocks of audio data.

After calling the prepareToPlay() method, this callback will be made each time the audio playback hardware (or whatever other destination the audio data is going to) needs another block of data.

It will generally be called on a high-priority system thread, or possibly even an interrupt, so be careful not to do too much work here, as that will cause audio glitches!

See also
  AudioSourceChannelInfo, prepareToPlay, releaseResources

Implemented in BufferingAudioSource, ChannelRemappingAudioSource, IIRFilterAudioSource, MixerAudioSource, ResamplingAudioSource, ReverbAudioSource, ToneGeneratorAudioSource, AudioTransportSource, AudioFormatReaderSource, MemoryAudioSource, and AudioAppComponent.

The documentation for this class was generated from the following file:

- juce_AudioSource.h